/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _SCPROPSTRLISTS_H_
#define _SCPROPSTRLISTS_H_

#include "SCGenInclude.h"
#include SC_INC_WINLIB(SCWinStrLists.h)
#include SC_INC_EMFLIB(SCGDIplusStrLists.h)

/////////////////////////////////////////////////////////////////////////////
// Types and general functions

// Property names
#define SC_T_Picture			_T("Picture")
	// Control-related
#define SC_T_CtlBorder			_T("CtlBorder")
#define SC_T_CtlColorStyle		_T("CtlColorStyle")
#define SC_T_CtlColor			_T("CtlColor")
	// Page-related
#define SC_T_PageBorderVisible	_T("PageBorderVisible")
#define SC_T_PageShadowVisible	_T("PageShadowVisible")
#define SC_T_PaperColorStyle	_T("PaperColorStyle")
#define SC_T_PaperColor			_T("PaperColor")
#define SC_T_FitMode			_T("FitMode")
#define SC_T_Scale				_T("Scale")
#define SC_T_MarginL			_T("LeftMargin")
#define SC_T_MarginT			_T("TopMargin")
#define SC_T_MarginR			_T("RightMargin")
#define SC_T_MarginB			_T("BottomMargin")
#define SC_T_PageOrientation	_T("PageOrientation")
#define SC_T_TransparencyMode	_T("TransparencyMode")
#define SC_T_ReverseVideoMode	_T("ReverseVideoMode")
	// GDI+-related
#define SC_T_GDIplusEnabled		_T("GDIplusEnabled")
#define SC_T_TextRenderingHint	_T("TextRenderingQuality")
#define SC_T_TextContrast		_T("TextContrast")
#define SC_T_SmoothingMode		_T("SmoothingMode")
#define SC_T_InterpolationMode	_T("InterpolationMode")
#define SC_T_PixelOffsetMode	_T("PixelOffsetMode")

// Extra for persistency
#define SC_T_Src				_T("Src")

// Aliases
#define SC_T_PageFitMode		SC_T_FitMode


/////////////////////////////////////////////////////////////////////////////
// Declarations (for enums)

	// Properties
SC_DECLARE_OLESTRINGS(CtlBorder)
//CtlColorStyle: see below

SC_DECLARE_OLESTRINGS(PageFitMode)
SC_DECLARE_OLESTRINGS(PageOrientation)
//PaperColorStyle: see below
SC_DECLARE_OLESTRINGS(TransparencyMode)
SC_DECLARE_OLESTRINGS(ReverseVideoMode)

	// Generic
SC_DECLARE_OLESTRINGS(ColorStyle)


/// Economizing some definitions
	// From generic ColorStyle
#define SCGetCtlColorStylePredefinedValue		SCGetColorStylePredefinedValue
#define SCGetCtlColorStylePredefinedCookie		SCGetColorStylePredefinedCookie
#define SCGetPaperColorStylePredefinedValue		SCGetColorStylePredefinedValue
#define SCGetPaperColorStylePredefinedCookie	SCGetColorStylePredefinedCookie
///

#endif //_SCPROPSTRLISTS_H_
//  ------------------------------------------------------------
