/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _SCZIPFILE_H_
#define _SCZIPFILE_H_

#include "SCGenInclude.h"
#include SC_INC_ZIPLIB(zlib.h)

#define SC_GZHEADER_MINSIZE		10

BOOL SCIsGZFile(LPCTSTR lpszFName);
BOOL SCIsGZFile(HANDLE hFile);
BOOL SCIsGZCandidate(LPBYTE lpBuff, DWORD dwSize, BOOL bFullCheck=FALSE);
BOOL SCUnzipGZFile(LPCTSTR lpszSrcFName, LPCTSTR lpszDestName);

BOOL SCUnzipGZFile(LPCTSTR lpszSrcFName, CMemFile& rMemFile);
BOOL SCUnzipGZFilePart(LPCTSTR lpszSrcFName, LPBYTE pBuff, DWORD dwQuant);

class CSCMemZip
{
public:
	CSCMemZip();
	~CSCMemZip();

	// getters
	CMemFile& SCGetMemFile() { return m_MemFile; }
	int SCGetState() const { return m_nRet; }
	int SCGetTotalIn() const { return m_zstrm.total_in; }
	LPCSTR SCGetNextIn() const { return (LPCSTR)m_zstrm.next_in; }
	DWORD SCGetHeaderSize() const { return m_dwHeaderSize; }

	// operation
	BOOL SCBeginUnzip(LPBYTE lpszSrcMem, long lSrcSize);
	BOOL SCUnzipChunk(LPBYTE lpszSrcMem, long lSrcSize);
	BOOL SCEndUnzip();
	BOOL SCIsAtEnd() const { return (m_nRet==Z_STREAM_END); }


private:
	z_stream	m_zstrm;
	CMemFile	m_MemFile;
	int			m_nRet;
	DWORD		m_dwHeaderSize;
};

#endif //_SCZIPFILE_H_
//  ------------------------------------------------------------
