/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/

#if !defined(AFX_IPFRAME_H__2DD2C527_33F4_4D22_93A9_0048B6F673D2__INCLUDED_)
#define AFX_IPFRAME_H__2DD2C527_33F4_4D22_93A9_0048B6F673D2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EMFtoolbar.h"
#include "SCGDIpToolbar.h"

class CInPlaceFrame : public COleDocIPFrameWnd
{
	DECLARE_DYNCREATE(CInPlaceFrame)
public:
	CInPlaceFrame();

// Attributes
public:
	CEMFToolBar& SCGetToolbar() { return m_wndToolBar; }
	CSCGDIpToolBar&  SCGetGDIPToolbar() { return m_wndGDIpToolbar; }
	void SCSetOrigFrame(CFrameWnd* pOrigFrame) { m_pOrigFrame = pOrigFrame; }

// Operations
public:
	void SCEnableGDIPlus(BOOL bEnable);
	void SCOnViewGdipBar();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CInPlaceFrame)
	public:
	virtual BOOL OnCreateControlBars(CFrameWnd* pWndFrame, CFrameWnd* pWndDoc);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CInPlaceFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
#ifdef SC_USE_IPSTATUSBAR
	CStatusBar		m_wndStatusBar;
#endif
	CEMFToolBar		m_wndToolBar;
	CSCGDIpToolBar	m_wndGDIpToolbar;
	BOOL			m_bGDIpEnabled;
	BOOL			m_bShowGDIpToolbar;

	COleDropTarget	m_dropTarget;
	COleResizeBar   m_wndResizeBar;

	CFrameWnd*		m_pOrigFrame;
	CFrameWnd*		m_pWndFrame;

// Generated message map functions
protected:
	//{{AFX_MSG(CInPlaceFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_IPFRAME_H__2DD2C527_33F4_4D22_93A9_0048B6F673D2__INCLUDED_)
