/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/

#if !defined(AFX_MAINFRM_H__0480C91D_A219_4861_BDA3_BB24F0DCD73C__INCLUDED_)
#define AFX_MAINFRM_H__0480C91D_A219_4861_BDA3_BB24F0DCD73C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EMFtoolbar.h"
#include "SCGDIpToolbar.h"
#include "IpFrame.h"

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:
	CEMFToolBar& SCGetToolbar() { return (!m_pIPFrame) ? m_wndToolBar : m_pIPFrame->SCGetToolbar(); }
	CSCGDIpToolBar&  SCGetGDIPToolbar() { return (!m_pIPFrame) ? m_wndGDIpToolbar : m_pIPFrame->SCGetGDIPToolbar(); }
	void SCSetOleIPFrameWnd(CInPlaceFrame* pOleIPFrameWnd) { m_pIPFrame = pOleIPFrameWnd; }

// Operations
public:
	void SCEnableGDIPlus(BOOL bEnable);
	void SCInitialShow();
	void SCOnIPControlBarsCreated();
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar		m_wndStatusBar;
	CEMFToolBar		m_wndToolBar;
	CSCGDIpToolBar	m_wndGDIpToolbar;
	BOOL			m_bGDIpEnabled;
	BOOL			m_bShowGDIpToolbar;
	CInPlaceFrame*  m_pIPFrame;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnUpdatePage(CCmdUI *pCmdUI);
	afx_msg void OnClose();
	afx_msg void OnUpdateViewGdipBar(CCmdUI* pCmdUI);
	afx_msg void OnViewGdipBar();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
	void SCFrameOpenFile(LPCTSTR szFilename);

private:
	BOOL m_bIsStandAlone;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__0480C91D_A219_4861_BDA3_BB24F0DCD73C__INCLUDED_)
