/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#if !defined(AFX_SCEMFXCOLORSPROPPAGE_H__B70EE3EB_7451_4BF1_B0C3_DA7CF05A4FD4__INCLUDED_)
#define AFX_SCEMFXCOLORSPROPPAGE_H__B70EE3EB_7451_4BF1_B0C3_DA7CF05A4FD4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SCEMFXColorsPropPage.h : header file
//

#include "SCEMFXBasePropPage.h"
#include "SCGenInclude.h"
#include SC_INC_WINLIB(SCColorBox.h)
#include SC_INC_WINLIB(SCWinGUI.h)


/////////////////////////////////////////////////////////////////////////////
// CSCEMFXColorsPropPage dialog

class CSCEMFXColorsPropPage : public CSCEMFXBasePropPage
{
	DECLARE_DYNCREATE(CSCEMFXColorsPropPage)

// Construction
public:
	CSCEMFXColorsPropPage();
	~CSCEMFXColorsPropPage();

// Dialog Data
	//{{AFX_DATA(CSCEMFXColorsPropPage)
	enum { IDD = IDD_PROPPAGE_COLORS };
	CSCColorBox	m_CmbPaperColorRGB;
	CSCSysColorBox	m_CmbPaperColorSys;
	int		m_nTransparencyMode;
	int		m_nReverseVideoMode;
	int		m_nPaperColorStyle;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSCEMFXColorsPropPage)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	public:
	virtual void OnOK();
	//}}AFX_VIRTUAL

protected:
	void SCEnableControls();

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSCEMFXColorsPropPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnRadioPapercolorTrans();
	afx_msg void OnRadioPapercolorSys();
	afx_msg void OnRadioPapercolorRgb();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


private:
	COLORREF m_nPaperColor;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCEMFXCOLORSPROPPAGE_H__B70EE3EB_7451_4BF1_B0C3_DA7CF05A4FD4__INCLUDED_)
