/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _SCGDIPTOOLBAR_H_
#define _SCGDIPTOOLBAR_H_

#include "SCGenInclude.h"
#include SC_INC_EMFLIB(SCGdiplusUtils.h)
#include SC_INC_WINLIB(SCTbComboBox.h)
#include SC_INC_WINLIB(SCWinGUI.h)

class CSCGDIpToolBar : public CToolBar
{
// Construction / Destruction / Creation
public:
	CSCGDIpToolBar::CSCGDIpToolBar();
	CSCGDIpToolBar::~CSCGDIpToolBar();
	BOOL SCCreate(CWnd* pParentWnd, UINT uiRes);

// Attributes
public:
	// getters
	SCGDIpDrawingAttributes* SCGetDrawingAttributes() { return m_pDrawingAttributes; }

	// setters
	void SCSetDrawingAttributes(SCGDIpDrawingAttributes* pDrawingAttributes);

// Operation
public:
	void SCReset();
	void SCEnableControls(BOOL bEnable=TRUE);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSCGDIpToolBar)
	//}}AFX_VIRTUAL

// Implementation
public:
	// special command routing to frame
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual CSize CalcDynamicLayout(int nLength, DWORD dwMode);

protected:
	BOOL SCCreateChildren();
	BOOL SCSetHorizontal();
	BOOL SCSetVertical();
	void SCUpdateControls();

	// Generated message map functions
protected:
	//{{AFX_MSG(CSCGDIpToolBar)
	afx_msg void OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar );
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
	SC_DECLARE_ENABLE_CONTROL()

// data
private:
	CSCTbComboBox				m_TextRenderingBox;
	CSCTbComboBox				m_CurveSmoothingBox;
	CSCTbComboBox				m_ImageSamplingBox;
	CSCTbComboBox				m_ImagePixelsOffsBox;
	CSliderCtrl					m_TextContrastSlider;
	SCGDIpDrawingAttributes*	m_pDrawingAttributes;
	BOOL						m_bVertical;
};

#endif //_SCGDIPTOOLBAR_H_
//  ------------------------------------------------------------
