/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#if !defined(AFX_SCEMFAXGDIPPROPPAGE_H__DC740512_E290_4E0A_AC7B_9512C3889CF8__INCLUDED_)
#define AFX_SCEMFAXGDIPPROPPAGE_H__DC740512_E290_4E0A_AC7B_9512C3889CF8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SCEMFAxGDIpPropPage.h : header file
//
#include "SCGenInclude.h"
#include SC_INC_WINLIB(SCWinGUI.h)

/////////////////////////////////////////////////////////////////////////////
// CSCEMFAxGDIpPropPage : Property page dialog

class CSCEMFAxGDIpPropPage : public COlePropertyPage
{
	DECLARE_DYNCREATE(CSCEMFAxGDIpPropPage)
	DECLARE_OLECREATE_EX(CSCEMFAxGDIpPropPage)

// Constructors
public:
	CSCEMFAxGDIpPropPage();

// Dialog Data
	//{{AFX_DATA(CSCEMFAxGDIpPropPage)
	enum { IDD = IDD_PROPPAGE_GDIPLUS };
	BOOL	m_bGDIplusEnabled;
	int		m_nTextRenderingHint;
	int		m_nTextContrast;
	int		m_nSmoothingMode;
	int		m_nInterpolationMode;
	int		m_nPixelOffsetMode;
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support
	void SCUpdateControls();
	void SCEnableControls(BOOL bEnable=TRUE);

// Message maps
protected:
	//{{AFX_MSG(CSCEMFAxGDIpPropPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnChkOptgenUsegdip();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	SC_DECLARE_ENABLE_CONTROL()

private:
	BOOL m_bGDIpOn; // dup of m_bGDIplusEnabled to avoid premature validation
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCEMFAXGDIPPROPPAGE_H__DC740512_E290_4E0A_AC7B_9512C3889CF8__INCLUDED_)
