/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#if !defined(AFX_SCEMFAXPPG_H__6F20202A_2ED4_40E7_8929_123CBEA9D4C1__INCLUDED_)
#define AFX_SCEMFAXPPG_H__6F20202A_2ED4_40E7_8929_123CBEA9D4C1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// SCEMFAxPpg.h : Declaration of the CSCEMFAxPropPage property page class.
#include "SCGenInclude.h"
#include SC_INC_WINLIB(SCOleBaseOlePPg.h)
#include SC_INC_WINLIB(SCColorBox.h)
#include SC_INC_WINLIB(SCZoomBox.h)
#include SC_INC_WINLIB(SCWinGUI.h)


////////////////////////////////////////////////////////////////////////////
// CSCEMFAxPropPage : See SCEMFAxPpg.cpp.cpp for implementation.

class CSCEMFAxPropPage : public CSCBaseOlePropertyPage
{
	DECLARE_DYNCREATE(CSCEMFAxPropPage)
	DECLARE_OLECREATE_EX(CSCEMFAxPropPage)

// Constructor
public:
	CSCEMFAxPropPage();

// Dialog Data
	//{{AFX_DATA(CSCEMFAxPropPage)
	enum { IDD = IDD_PROPPAGE_SCEMFAX };
	CComboBox	m_CmbCtlBorder;
	CSCZoomBox	m_CmbZoomBox;
	CSCColorBox	m_CmbCtlColorRGB;
	CSCSysColorBox	m_CmbCtlColorSys;
	BOOL	m_bPageBorderVisible;
	BOOL	m_bPageShadowVisible;
	int		m_nPageOrientation;
	int		m_nMarginL;
	int		m_nMarginT;
	int		m_nMarginR;
	int		m_nMarginB;
	int		m_nCtlColorStyle;
	//}}AFX_DATA

//////////////////////////////////////////////////////////////////////////////////
// Note: this AFX_ block was not added by ClassWizard, I added it manually.
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSCEMFAxPropPage)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL
/////////////////////////////////////////////////////////////////////////////////

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	SC_DECLARE_ENABLE_CONTROL()
	void SCEnableControls();

// Message maps
protected:
	//{{AFX_MSG(CSCEMFAxPropPage)
	virtual BOOL OnInitDialog();
	afx_msg void OnRadioCtlColorTrans();
	afx_msg void OnRadioCtlColorSys();
	afx_msg void OnRadioCtlColorRgb();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


private:
	OLE_COLOR	m_nCtlColor;
	float		m_fScale;
	DWORD		m_nFitMode;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCEMFAXPPG_H__6F20202A_2ED4_40E7_8929_123CBEA9D4C1__INCLUDED)
