/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _SCEMFDATAPPROP_H_
#define _SCEMFDATAPPROP_H_

#include "SCGenInclude.h"
#include SC_INC_SHARED(SCZipFile.h)

/////////////////////////////////////////////////////////////////////////////
// CSCEMFDataPathProperty command target

class CSCEMFDataPathProperty : public CDataPathProperty
{
	DECLARE_DYNAMIC(CSCEMFDataPathProperty)
//Constructor
public:
	CSCEMFDataPathProperty(COleControl* pControl = NULL);

// Attributes
public:
	enum DLState
	{
		dlNone,
		dlEMFBody,
		dlDone
	} m_dlState;

	CMemFile		m_CacheFile;
	HENHMETAFILE	m_hEMF;
	DWORD			m_dwArrivedBytes;	// arrived bytes
	DWORD			m_dwRead;			// expanded bytes in cache
	DWORD			m_dwTotal;			// total expected expanded bytes
	DWORD			m_dwPos;			// useable byte
	DWORD			m_dwNeeded;			// needed to complete records
	DWORD			m_dwNbRecs;
	CSCMemZip		m_MemZip;

// Operations
public:
	BOOL SCReadBytes(DWORD dwArriving, LPBYTE pb, DWORD dwLen);
	DWORD SCReadRecords(DWORD dwArriving, LPBYTE& pb);
	HENHMETAFILE SCDetachEMF() { HENHMETAFILE hEMF = m_hEMF; m_hEMF = NULL; return hEMF; }


// Overrides
public:
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSCEMFDataPathProperty)
	public:
	virtual void ResetData();
	protected:
	virtual void OnDataAvailable(DWORD dwSize, DWORD bscfFlag);
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(CSCEMFDataPathProperty)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
public:
	virtual ~CSCEMFDataPathProperty();

protected:
	DWORD	SCTransferFileContent(CFile* pFrom, CFile* pTo, DWORD dwAmount);
	BOOL	m_bCheckZip;
	BOOL	m_bIsGZ;
};

#endif //_SCEMFDATAPPROP_H_
//  ------------------------------------------------------------
