/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/


#include "stdafx.h"
#include "SCEditBox.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSCEditBox

CSCEditBox::CSCEditBox():
	m_bTrapEnter(FALSE)
{
}

void CSCEditBox::SCReset()
{
	if (IsWindow(m_hWnd))
		SetWindowText(_T(""));
}

CSCEditBox::~CSCEditBox()
{
}

BEGIN_MESSAGE_MAP(CSCEditBox, CEdit)
	//{{AFX_MSG_MAP(CSCEditBox)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSCEditBox message handlers

BOOL CSCEditBox::PreTranslateMessage(MSG* pMsg)
{
	if ((pMsg->message == WM_KEYDOWN) && (pMsg->wParam == VK_RETURN))
	{
		// when the "enter" key is hit in the EditBox we want to notify
		// the parent window
		if ((pMsg->lParam & 0x40000000) == 0)   // Not a repeat.
		{
			CWnd *pParent = GetParent();
			ASSERT(pParent);
			
			if (pParent)
			{
				NMHDR nmhdr;
				nmhdr.code = EN_CHANGE;
				nmhdr.hwndFrom = m_hWnd;
				nmhdr.idFrom = GetDlgCtrlID();
				
				pParent->SendMessage(WM_NOTIFY, (WPARAM)nmhdr.idFrom, (LPARAM)&nmhdr);
			}
		}
		if (m_bTrapEnter)
			return TRUE;
	}
	
	return CEdit::PreTranslateMessage(pMsg);
}
