/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _SCOLEBASEOLEPPG_H_
#define _SCOLEBASEOLEPPG_H_
#include <afxctl.h>         // MFC support for ActiveX Controls

/////////////////////////////////////////////////////////////////////////////
// Support macros
#include "SCPropHelpers.h"

/////////////////////////////////////////////////////////////////////////////
// Base Ole Property Page Class

class CSCBaseOlePropertyPage : public COlePropertyPage
{
	DECLARE_DYNAMIC(CSCBaseOlePropertyPage)

// Constructors/Destructor
public:
	CSCBaseOlePropertyPage(UINT idDlg, UINT idCaption);
	~CSCBaseOlePropertyPage();

// Operations
//		void SCSetLCID(LCID lcid) { m_lcid = lcid; }

// Implementation

// Overridables
	virtual void OnObjectsChanged();

protected:
// VC won't allow us to do it. We must trick.
//		template < class cppT, int oleT >
//			BOOL SCSetAnyProp(cppT cppValue, LPCTSTR pszPropName);
//		template < class cppT, int oleT >
//			BOOL SCGetAnyProp(cppT* pcppValue, LPCTSTR pszPropName);

	BOOL SCSetDWORDProp(DWORD dwValue, LPCTSTR pszPropName);
	BOOL SCGetDWORDProp(DWORD* pdwValue, LPCTSTR pszPropName);
	BOOL SCSetFloatProp(float fValue, LPCTSTR pszPropName);
	BOOL SCGetFloatProp(float* pfValue, LPCTSTR pszPropName);

	// Generated message map functions
	//{{AFX_MSG(CSCBaseOlePropertyPage)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	LCID			m_lcid;
	LPDISPATCH*		m_plpDisp;
	ULONG			m_ulNbObjects;
};


#endif //_SCOLEBASEOLEPPG_H_
//  ------------------------------------------------------------
