/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/


#include "stdafx.h"
#include "SCPreviewView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CSCPreviewView, CPreviewView)

BEGIN_MESSAGE_MAP(CSCPreviewView, CPreviewView)
	//{{AFX_MSG_MAP(CSCPreviewView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSCPreviewView::CSCPreviewView()
{

}

CSCPreviewView::~CSCPreviewView()
{

}

BOOL CSCPreviewView::PreCreateWindow(CREATESTRUCT& cs)
{
	if (cs.lpszClass == NULL)
		cs.lpszClass = AfxRegisterWndClass(CS_DBLCLKS|CS_HREDRAW|CS_VREDRAW|CS_BYTEALIGNCLIENT);

	return CView::PreCreateWindow(cs);
}

void CSCPreviewView::OnDraw(CDC* pDC) 
{
	//recalculate scale ratio
	PositionPage(0);

	//store scale ratio
	float fRatio = (float)m_pPageInfo[0].sizeScaleRatio.cx / (float)m_pPageInfo[0].sizeScaleRatio.cy;
	m_pPreviewInfo->m_lpUserData = &fRatio;

	CPreviewView::OnDraw(pDC);
}

