/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _SCPROPHELPERS_H_
#define _SCPROPHELPERS_H_

/////////////////////////////////////////////////////////////////////////////
// Support macros for Ole property pages

/// for enum properties (accessed through cookie)
#define SCDECL_PROP_COOKIE(memberCookie, pprop) \
	int nOld##pprop##Cookie = memberCookie

#define SCDDP_COOKIE_SETPROP(memberCookie, pprop) \
		if (nOld##pprop##Cookie != memberCookie) \
		{\
			DWORD dwPPropValue;\
			if (SCGet##pprop##PredefinedValue(dwPPropValue, memberCookie)) \
				SCSetDWORDProp(dwPPropValue, _T(#pprop)); \
		}

#define SCDDP_COOKIE_GETPROP(memberCookie, pprop) \
	{\
		DWORD dwPPropValue;\
		SCGetDWORDProp(&dwPPropValue, _T(#pprop));\
		DWORD dwCookie;\
		if (SCGet##pprop##PredefinedCookie(dwCookie, dwPPropValue))\
		{\
			memberCookie = dwCookie;\
		}\
	}

/// for other properties (accessed through value)
#define SCDECL_DWORD_PROP(memberValue, pprop) \
	DWORD dwOld##pprop##Value = memberValue

#define SCDDP_SETPROP(memberValue, pprop) \
		if (dwOld##pprop##Value != memberValue) \
		{\
			SCSetDWORDProp(memberValue, _T(#pprop)); \
		}

#define SCDDP_GETPROP(memberValue, pprop) \
	{\
		DWORD dwPPropValue;\
		SCGetDWORDProp(&dwPPropValue, _T(#pprop));\
		memberValue = dwPPropValue;\
	}

#endif //_SCPROPHELPERS_H_
//  ------------------------------------------------------------
