/*
*	This file is part of the EMFexplorer projet.
*	Copyright (C) 2004 Smith Charles.
*
*	This library is free software; you can redistribute it and/or
*	modify it under the terms of the GNU Lesser General Public
*	License as published by the Free Software Foundation; either
*	version 2.1 of the License, or (at your option) any later version.
*
*   This library is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*   Lesser General Public License for more details.
*
*   You should have received a copy of the GNU Lesser General Public
*   License along with this library; if not, write to the Free Software
*   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
*
*	Extension: for commercial use, apply the Equity Public License, which
*	adds to the normal terms of the GLPL a condition of donation to the author.
*   If you are interested in support for this source code,
*   contact Smith Charles <smith.charles@free.fr> for more information.
*/
#ifndef _WSTREDIT_H_
#define _WSTREDIT_H_

#if _MSC_VER >= 1000 
#pragma once 
#endif // _MSC_VER >= 1000 

#include <afxcmn.h>
#include <afxext.h>

///////////////////////////////////////////////////////////////////////////// 
// CSCRichEdit window 

class CSCRichEdit : public CRichEditCtrl 
{ 
	// Construction 
public: 
	CSCRichEdit(); 
	
	// Attributes 
public: 
	
	// Operations 
public: 
	void OnFocus(BOOL bFocus); 
	void SCToggleItalicText(BOOL bItalic = TRUE); 
	void SCSetTextColor(COLORREF crColor = RGB(255, 255, 255)); 
	void SCToggleBoldText(BOOL bBold = TRUE); 
	void SCAddText(LPCTSTR szTextIn); 
	void SCSetEmpty(); 
	void SCSetFontSize(UINT uiSize);
	void SCSetFont(LPCTSTR lpszFace, UINT uiSize);

	BOOL SCCreateHidden(BOOL bRTF=TRUE);
	BOOL SCLoadFromFile(LPCTSTR lpszFname, BOOL bRTF);
	BOOL SCLoadFromMem(LPBYTE lpByte, DWORD dwLen, BOOL bRTF);
	BOOL SCLoadFromHGlobal(HANDLE hMem, BOOL bRTF);
	
	// Overrides 
	// ClassWizard generated virtual function overrides 
	//{{AFX_VIRTUAL(CSCRichEdit) 
	//}}AFX_VIRTUAL 
	
	// Implementation 
public: 
	virtual ~CSCRichEdit(); 

	// static
	static DWORD CALLBACK SCFileLoad(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG FAR *pcb);
	static DWORD CALLBACK SCRTFStreamLoad(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG FAR *pcb);
	static DWORD CALLBACK SCTEXTStreamLoad(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG FAR *pcb);
	
	// Generated message map functions 
protected: 
	//{{AFX_MSG(CSCRichEdit) 
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct); 
	//}}AFX_MSG 
	
	DECLARE_MESSAGE_MAP() 
}; 

///////////////////////////////////////////////////////////////////////////// 

//{{AFX_INSERT_LOCATION}} 
// Microsoft Developer Studio will insert additional declarations immediately before the previous line. 


#endif //_WSTREDIT_H_
//  ------------------------------------------------------------
